'''
  Folding@Home Client Control (FAHControl)
  Copyright (C) 2010-2011 Stanford University

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import urllib2
import re


class Project:
    def __init__(self, id, description):
        self.id = id
        self.description = description


    def valid(self): return self.description is not None


class ProjectManager:
    base = 'http://fah-web.stanford.edu/cgi-bin/'\
        'fahproject.overusingIPswillbebanned'


    def __init__(self, db):
        self.db = db
        self.table = db.get_table('projects')
        self.projects = {}


    def load(self, id):
        for row in self.table.select(self.db, where = 'id=%d' % id):
            return Project(id, row['description'])

        project = self.download(id)
        if project.valid():
            self.db.insert('projects', id = id,
                           description = project.description)

        return project


    def download(self, id):
        url = '%s?p=%d' % (ProjectManager.base, id)
        data = urllib2.urlopen(url).read()

        start_key = 'Project %d</A></b></font></TD></TR><TR><TD>' % id
        end_key = '<BR><BR><BR>'

        start = data.find(start_key)
        if start != -1:
            start += len(start_key)

            end = data.find(end_key, start)
            if end != -1:
                desc = data[start : end]
                desc = ' '.join(desc.strip().split())
                desc = re.sub(r'<[pP]>', '\n\n', desc)
                desc = re.sub(r'<[^>]+>', '', desc).strip()

                return Project(id, desc)

        raise Exception, 'Failed to parse project description: ' + url


    def get(self, id):
        if not id in self.projects:
            try:
                self.projects[id] = self.load(id)        

            except Exception, e:
                print str(e)
                raise
                self.projects[id] = Project(id, None, None)

        return self.projects[id]
